package execution;

import org.graphstream.algorithm.generator.RandomGenerator;
import org.graphstream.graph.Graph;
import org.graphstream.graph.implementations.SingleGraph;
import org.graphstream.algorithm.Dijkstra;
import unlh.graph.algo.NaiveDijkstra;

import java.io.BufferedWriter;
import java.io.FileWriter;

public class GSShortestPath {
    public static void main(String argvs[]) throws Exception {
        long debut, fin, total; // temps de debut et fin
        int cpt = 1, len = 500, max = 500;
        Graph graph = new SingleGraph("GSShortestPath");
        RandomGenerator gen = new RandomGenerator(6, false, true); // creation d'un générateur

        gen.setEdgeAttributesRange(10.0, 50.0); // definition de l'attribut des arcs depuis un range[10.0, 50.0]
        gen.addEdgeAttribute("cap"); // attribution des valeurs vers un attribut nommé "cap"
        gen.addSink(graph);

        BufferedWriter writer = new BufferedWriter(new FileWriter("data/graphstream_dijkistra.dat"));
        while (cpt <= 100) {
            gen.begin();
            // génération de 10000 noeuds
            for (int i = 0; i < len; i++)
                gen.nextEvents();
            gen.end();

            // on choisit le premier noeud comme source
            // calcul le temps d'execution lors de l'appelle de `compute()`
            debut = System.currentTimeMillis();

            Dijkstra dijkstra = new Dijkstra(Dijkstra.Element.EDGE, "result", "length");
            dijkstra.setSource(graph.getNode(0));
            dijkstra.init(graph);
            dijkstra.compute();

            fin = System.currentTimeMillis();
            total = fin - debut;
            System.out.println("[** GS" + graph.getNodeCount() + "] Execution time : " + total + " ms");
            writer.write(String.format("%d%6d%n", graph.getNodeCount(), total));
            graph.clear();
            cpt++;
            len = max * cpt;
        }
        writer.close();
    }
}
